(add-to-list 'load-path (concat eli-extras-dir "w3m/emacs-w3m/"))
(require 'w3m)

(setq
 ;; >> w3m
 ;; ?? w3m-user-agent "Emacs-w3m/1.4.414 w3m/0.5.2"
 ;; ?? w3m-add-user-agent t
 w3m-coding-system 'utf-8
 w3m-terminal-coding-system 'utf-8
 w3m-output-coding-system 'utf-8
 w3m-input-coding-system 'utf-8
 w3m-file-coding-system 'utf-8
 w3m-file-name-coding-system 'utf-8
 w3m-default-coding-system 'iso-8859-1
 w3m-key-binding 'info ; does this do anything?
 w3m-profile-directory "~/.w3m"
 w3m-init-file "~/.emacs-w3m"
 w3m-default-save-directory "~/.w3m"
 w3m-default-directory (expand-file-name "~/")
 w3m-delete-duplicated-empty-lines t
 w3m-default-display-inline-images t ; is this too much?
 w3m-toggle-inline-images-permanently t
 w3m-quick-start t
 w3m-home-page "about:"
 w3m-keep-arrived-urls 500
 w3m-prefer-cache nil
 w3m-keep-cache-size 300
 w3m-follow-redirection 9
 ;; w3m-redirect-with-get t
 w3m-resize-image-scale 50
 w3m-horizontal-scroll-columns 10
 w3m-horizontal-shift-columns 2
 w3m-view-recenter 1
 w3m-use-form t ; experimental
 w3m-submit-form-safety-check nil
 w3m-use-cookies t ; experimental
 w3m-edit-function 'find-file
 w3m-edit-function-alist '()
 w3m-url-local-directory-alist '()
 w3m-track-mouse t
 w3m-show-decoded-url t
 w3m-use-title-buffer-name nil ; doesn't make much sense
 w3m-use-japanese-menu nil
 w3m-use-tab t
 w3m-add-tab-number nil
 w3m-new-session-url "about://bookmark/"
 w3m-use-favicon t
 w3m-show-graphic-icons-in-mode-line nil
 w3m-show-graphic-icons-in-header-line t
 ;; ?? w3m-pop-up-windows t
 ;; ?? w3m-pop-up-frames nil
 ;; ?? w3m-auto-show t
 ;; ?? w3m-horizontal-scroll-division 4
 w3m-use-refresh t
 w3m-local-directory-view-method 'w3m-cgi ; ? 'w3m-dtree
 w3m-add-referer
   '("\\`http:" . "\\`http://\\(?:localhost\\|127\\.0\\.0\\.1\\)/")
 w3m-uri-replace-alist
   '(("\\`g:" w3m-search-uri-replace "google")
     ("\\`gg:" w3m-search-uri-replace "google")
     ("\\`ggg:" w3m-search-uri-replace "google groups")
     ("\\`ya:" w3m-search-uri-replace "yahoo")
     ;; ("\\`al:" w3m-search-uri-replace "altavista")
     ;; ("\\`bts:" w3m-search-uri-replace "debian-bts")
     ;; ("\\`dpkg:" w3m-search-uri-replace "debian-pkg")
     ;; ("\\`archie:" w3m-search-uri-replace "iij-archie")
     ;; ("\\`alc:" w3m-search-uri-replace "alc")
     ("\\`urn:ietf:rfc:\\([0-9]+\\)" w3m-pattern-uri-replace
      "http://www.ietf.org/rfc/rfc\\1.txt")
     )
 w3m-enable-google-feeling-lucky t
 w3m-google-feeling-lucky-charset "UTF-8"
 w3m-process-modeline-format " %s loaded"
 w3m-ignored-image-url-regexp '()
 w3m-refresh-minimum-interval 60
 w3m-confirm-leaving-secure-page t ; nil?
 w3m-db-history-display-size nil ; ?
 w3m-use-header-line t
 w3m-use-header-line-title nil ; effective when use-tab is nil
 w3m-session-autosave t
 w3m-session-deleted-save t
 w3m-session-crash-recovery t ; ??
 w3m-form-use-fancy-faces t
 w3m-form-treat-textarea-size t
 w3m-form-use-textarea-backup t
 w3m-form-textarea-file-expire-date 3
 w3m-form-textarea-file-coding-system 'utf-8
 w3m-form-textarea-edit-mode 'indented-text-mode
 w3m-form-input-textarea-buffer-lines 10
 )

;; (defun my-w3m-goto-url ()
;;   (interactive)
;;   (let ((minibuffer-setup-hook minibuffer-setup-hook))
;;     (add-hook 'minibuffer-setup-hook
;;               (lambda ()
;;                 (goto-char (point-max))
;;                 (ensure-mark)
;;                 (goto-char (point-min)))
;;               t)
;;     (call-interactively 'w3m-goto-url)))

(defun w3m-mouse-view-this-url-or-next-page (event &optional arg)
  (interactive "e\nP")
  (mouse-set-point event)
  (let ((url (w3m-anchor))
        (act (w3m-action)))
    (cond
      (act (eval act))
      (url (w3m-view-this-url-1 url arg nil))
      ((w3m-image)
       (if (w3m-display-graphic-p)
         (w3m-toggle-inline-image)
         (w3m-view-image)))
      ((setq url (w3m-url-at-point))
       (unless (eq 'quit (setq url (w3m-input-url nil url 'quit)))
         (w3m-view-this-url-1 url arg nil)))
      (t (w3m-view-next-page)))))

(let ((m w3m-mode-map))
  (dolist (k '(left right up down))
    (define-key m (vector (list k)) nil))
  (define-keys m
    '([mouse-2] w3m-mouse-view-this-url-new-session)
    '([mouse-1] w3m-mouse-view-this-url)
    '([S-mouse-1] w3m-mouse-view-this-url)
    '([S-mouse-4] w3m-mouse-view-this-url-or-next-page)
    '([S-mouse-5] w3m-view-previous-page)
    '([(shift tab)] nil)
    '("n" w3m-view-next-page)
    '("p" w3m-view-previous-page)
    '("l" w3m-view-previous-page)
    '("o" w3m-goto-url)
    '("\C-o" w3m-goto-url)))
